Index: qtbase-everywhere-src-5.13.1/src/gui/text/qdistancefield.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qdistancefield.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qdistancefield.cpp
@@ -778,8 +778,8 @@ bool qt_fontHasNarrowOutlines(QFontEngin
 
     QImage im;
 
-    const glyph_t glyph = fe->glyphIndex('O');
-    if (glyph != 0)
+    const QGlyph glyph = fe->glyphIndex('O');
+    if (glyph.glyph != 0)
         im = fe->alphaMapForGlyph(glyph, QFixed(), QTransform());
 
     Q_ASSERT(fe->ref.load() == 0);
@@ -899,17 +899,17 @@ QDistanceField::QDistanceField(int width
 {
 }
 
-QDistanceField::QDistanceField(const QRawFont &font, glyph_t glyph, bool doubleResolution)
+QDistanceField::QDistanceField(const QRawFont &font, glyph__t glyph, bool doubleResolution)
 {
     setGlyph(font, glyph, doubleResolution);
 }
 
-QDistanceField::QDistanceField(QFontEngine *fontEngine, glyph_t glyph, bool doubleResolution)
+QDistanceField::QDistanceField(QFontEngine *fontEngine, const QGlyph &glyph, bool doubleResolution)
 {
     setGlyph(fontEngine, glyph, doubleResolution);
 }
 
-QDistanceField::QDistanceField(const QPainterPath &path, glyph_t glyph, bool doubleResolution)
+QDistanceField::QDistanceField(const QPainterPath &path, const QGlyph &glyph, bool doubleResolution)
 {
     QPainterPath dfPath = path;
     dfPath.translate(-dfPath.boundingRect().topLeft());
@@ -930,12 +930,12 @@ bool QDistanceField::isNull() const
     return !d->data;
 }
 
-glyph_t QDistanceField::glyph() const
+QGlyph QDistanceField::glyph() const
 {
     return d->glyph;
 }
 
-void QDistanceField::setGlyph(const QRawFont &font, glyph_t glyph, bool doubleResolution)
+void QDistanceField::setGlyph(const QRawFont &font, glyph__t glyph, bool doubleResolution)
 {
     QRawFont renderFont = font;
     renderFont.setPixelSize(QT_DISTANCEFIELD_BASEFONTSIZE(doubleResolution) * QT_DISTANCEFIELD_SCALE(doubleResolution));
@@ -945,10 +945,10 @@ void QDistanceField::setGlyph(const QRaw
     path.setFillRule(Qt::WindingFill);
 
     d = QDistanceFieldData::create(path, doubleResolution);
-    d->glyph = glyph;
+    d->glyph = {0, glyph};
 }
 
-void QDistanceField::setGlyph(QFontEngine *fontEngine, glyph_t glyph, bool doubleResolution)
+void QDistanceField::setGlyph(QFontEngine *fontEngine, const QGlyph &glyph, bool doubleResolution)
 {
     QFixedPoint position;
     QPainterPath path;
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qdistancefield_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qdistancefield_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qdistancefield_p.h
@@ -72,14 +72,14 @@ int Q_GUI_EXPORT QT_DISTANCEFIELD_HIGHGL
 class Q_GUI_EXPORT QDistanceFieldData : public QSharedData
 {
 public:
-    QDistanceFieldData() : glyph(0), width(0), height(0), nbytes(0), data(0) {}
+    QDistanceFieldData() : glyph{0,0}, width(0), height(0), nbytes(0), data(0) {}
     QDistanceFieldData(const QDistanceFieldData &other);
     ~QDistanceFieldData();
 
     static QDistanceFieldData *create(const QSize &size);
     static QDistanceFieldData *create(const QPainterPath &path, bool doubleResolution);
 
-    glyph_t glyph;
+    QGlyph glyph;
     int width;
     int height;
     int nbytes;
@@ -91,15 +91,15 @@ class Q_GUI_EXPORT QDistanceField
 public:
     QDistanceField();
     QDistanceField(int width, int height);
-    QDistanceField(const QRawFont &font, glyph_t glyph, bool doubleResolution = false);
-    QDistanceField(QFontEngine *fontEngine, glyph_t glyph, bool doubleResolution = false);
-    QDistanceField(const QPainterPath &path, glyph_t glyph, bool doubleResolution = false);
+    QDistanceField(const QRawFont &font, glyph__t glyph, bool doubleResolution = false);
+    QDistanceField(QFontEngine *fontEngine, const QGlyph &glyph, bool doubleResolution = false);
+    QDistanceField(const QPainterPath &path, const QGlyph &glyph, bool doubleResolution = false);
 
     bool isNull() const;
 
-    glyph_t glyph() const;
-    void setGlyph(const QRawFont &font, glyph_t glyph, bool doubleResolution = false);
-    void setGlyph(QFontEngine *fontEngine, glyph_t glyph, bool doubleResolution = false);
+    QGlyph glyph() const;
+    void setGlyph(const QRawFont &font, glyph__t glyph, bool doubleResolution = false);
+    void setGlyph(QFontEngine *fontEngine, const QGlyph &glyph, bool doubleResolution = false);
 
     int width() const;
     int height() const;
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontengine_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_p.h
@@ -143,7 +143,7 @@ public:
         QFixed lineWidth;
     };
     virtual Properties properties() const;
-    virtual void getUnscaledGlyph(glyph_t glyph, QPainterPath *path, glyph_metrics_t *metrics);
+    virtual void getUnscaledGlyph(const QGlyph &glyph, QPainterPath *path, glyph_metrics_t *metrics);
     QByteArray getSfntTable(uint tag) const;
     virtual bool getSfntTableData(uint tag, uchar *buffer, uint *length) const;
 
@@ -167,16 +167,16 @@ public:
     virtual QFixed emSquareSize() const { return ascent(); }
 
     /* returns 0 as glyph index for non existent glyphs */
-    virtual glyph_t glyphIndex(uint ucs4) const = 0;
+    virtual QGlyph glyphIndex(uint ucs4) const = 0;
     virtual bool stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, ShaperFlags flags) const = 0;
     virtual void recalcAdvances(QGlyphLayout *, ShaperFlags) const {}
     virtual void doKerning(QGlyphLayout *, ShaperFlags) const;
 
-    virtual void addGlyphsToPath(glyph_t *glyphs, QFixedPoint *positions, int nglyphs,
+    virtual void addGlyphsToPath(const QGlyph *glyphs, QFixedPoint *positions, int nglyphs,
                                  QPainterPath *path, QTextItem::RenderFlags flags);
 
     void getGlyphPositions(const QGlyphLayout &glyphs, const QTransform &matrix, QTextItem::RenderFlags flags,
-                           QVarLengthArray<glyph_t> &glyphs_out, QVarLengthArray<QFixedPoint> &positions);
+                           QVarLengthArray<QGlyph> &glyphs_out, QVarLengthArray<QFixedPoint> &positions);
 
     virtual void addOutlineToPath(qreal, qreal, const QGlyphLayout &, QPainterPath *, QTextItem::RenderFlags flags);
     void addBitmapFontToPath(qreal x, qreal y, const QGlyphLayout &, QPainterPath *, QTextItem::RenderFlags);
@@ -185,29 +185,29 @@ public:
      * Returns an image indexed_8 with index values ranging from 0=fully transparent to 255=opaque
      */
     // ### Refactor this into a smaller and more flexible API.
-    virtual QImage alphaMapForGlyph(glyph_t);
-    virtual QImage alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition);
-    virtual QImage alphaMapForGlyph(glyph_t, const QTransform &t);
-    virtual QImage alphaMapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t);
-    virtual QImage alphaRGBMapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t);
-    virtual QImage bitmapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t, const QColor &color = QColor());
-    virtual QImage *lockedAlphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition,
+    virtual QImage alphaMapForGlyph(const QGlyph &);
+    virtual QImage alphaMapForGlyph(const QGlyph & glyph, QFixed subPixelPosition);
+    virtual QImage alphaMapForGlyph(const QGlyph &, const QTransform &t);
+    virtual QImage alphaMapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t);
+    virtual QImage alphaRGBMapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t);
+    virtual QImage bitmapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t, const QColor &color = QColor());
+    virtual QImage *lockedAlphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition,
                                            GlyphFormat neededFormat,
                                            const QTransform &t = QTransform(),
                                            QPoint *offset = 0);
     virtual void unlockAlphaMapForGlyph();
     virtual bool hasInternalCaching() const { return false; }
 
-    virtual glyph_metrics_t alphaMapBoundingBox(glyph_t glyph, QFixed /*subPixelPosition*/, const QTransform &matrix, GlyphFormat /*format*/)
+    virtual glyph_metrics_t alphaMapBoundingBox(const QGlyph &glyph, QFixed /*subPixelPosition*/, const QTransform &matrix, GlyphFormat /*format*/)
     {
         return boundingBox(glyph, matrix);
     }
 
-    virtual void removeGlyphFromCache(glyph_t);
+    virtual void removeGlyphFromCache(const QGlyph &);
 
     virtual glyph_metrics_t boundingBox(const QGlyphLayout &glyphs) = 0;
-    virtual glyph_metrics_t boundingBox(glyph_t glyph) = 0;
-    virtual glyph_metrics_t boundingBox(glyph_t glyph, const QTransform &matrix);
+    virtual glyph_metrics_t boundingBox(const QGlyph &glyph) = 0;
+    virtual glyph_metrics_t boundingBox(const QGlyph &glyph, const QTransform &matrix);
     glyph_metrics_t tightBoundingBox(const QGlyphLayout &glyphs);
 
     virtual QFixed ascent() const = 0;
@@ -224,9 +224,9 @@ public:
     virtual qreal minLeftBearing() const;
     virtual qreal minRightBearing() const;
 
-    virtual void getGlyphBearings(glyph_t glyph, qreal *leftBearing = 0, qreal *rightBearing = 0);
+    virtual void getGlyphBearings(const QGlyph &glyph, qreal *leftBearing = 0, qreal *rightBearing = 0);
 
-    inline bool canRender(uint ucs4) const { return glyphIndex(ucs4) != 0; }
+    inline bool canRender(uint ucs4) const { return glyphIndex(ucs4).glyph != 0; }
     virtual bool canRender(const QChar *str, int len) const;
 
     virtual bool supportsTransformation(const QTransform &transform) const;
@@ -248,7 +248,7 @@ public:
                 || script == QChar::Script_Khmer || script == QChar::Script_Nko);
     }
 
-    virtual int getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints);
+    virtual int getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints);
 
     void clearGlyphCache(const void *key);
     void setGlyphCache(const void *key, QFontEngineGlyphCache *data);
@@ -411,7 +411,7 @@ public:
     QFontEngineBox(int size);
     ~QFontEngineBox();
 
-    virtual glyph_t glyphIndex(uint ucs4) const override;
+    virtual QGlyph glyphIndex(uint ucs4) const override;
     virtual bool stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, ShaperFlags flags) const override;
     virtual void recalcAdvances(QGlyphLayout *, ShaperFlags) const override;
 
@@ -419,7 +419,7 @@ public:
     virtual void addOutlineToPath(qreal x, qreal y, const QGlyphLayout &glyphs, QPainterPath *path, QTextItem::RenderFlags flags) override;
 
     virtual glyph_metrics_t boundingBox(const QGlyphLayout &glyphs) override;
-    virtual glyph_metrics_t boundingBox(glyph_t glyph) override;
+    virtual glyph_metrics_t boundingBox(const QGlyph &glyph) override;
     virtual QFontEngine *cloneWithSize(qreal pixelSize) const override;
 
     virtual QFixed ascent() const override;
@@ -429,7 +429,7 @@ public:
     virtual qreal maxCharWidth() const override;
     virtual qreal minLeftBearing() const override { return 0; }
     virtual qreal minRightBearing() const override { return 0; }
-    virtual QImage alphaMapForGlyph(glyph_t) override;
+    virtual QImage alphaMapForGlyph(const QGlyph &) override;
 
     virtual bool canRender(const QChar *string, int len) const override;
 
@@ -449,16 +449,16 @@ public:
     explicit QFontEngineMulti(QFontEngine *engine, int script, const QStringList &fallbackFamilies = QStringList());
     ~QFontEngineMulti();
 
-    virtual glyph_t glyphIndex(uint ucs4) const override;
+    virtual QGlyph glyphIndex(uint ucs4) const override;
     virtual bool stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, ShaperFlags flags) const override;
 
     virtual glyph_metrics_t boundingBox(const QGlyphLayout &glyphs) override;
-    virtual glyph_metrics_t boundingBox(glyph_t glyph) override;
+    virtual glyph_metrics_t boundingBox(const QGlyph &glyph) override;
 
     virtual void recalcAdvances(QGlyphLayout *, ShaperFlags) const override;
     virtual void doKerning(QGlyphLayout *, ShaperFlags) const override;
     virtual void addOutlineToPath(qreal, qreal, const QGlyphLayout &, QPainterPath *, QTextItem::RenderFlags flags) override;
-    virtual void getGlyphBearings(glyph_t glyph, qreal *leftBearing = 0, qreal *rightBearing = 0) override;
+    virtual void getGlyphBearings(const QGlyph &glyph, qreal *leftBearing = 0, qreal *rightBearing = 0) override;
 
     virtual QFixed ascent() const override;
     virtual QFixed capHeight() const override;
@@ -466,11 +466,11 @@ public:
     virtual QFixed leading() const override;
     virtual QFixed xHeight() const override;
     virtual QFixed averageCharWidth() const override;
-    virtual QImage alphaMapForGlyph(glyph_t) override;
-    virtual QImage alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition) override;
-    virtual QImage alphaMapForGlyph(glyph_t, const QTransform &t) override;
-    virtual QImage alphaMapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t) override;
-    virtual QImage alphaRGBMapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t) override;
+    virtual QImage alphaMapForGlyph(const QGlyph &) override;
+    virtual QImage alphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition) override;
+    virtual QImage alphaMapForGlyph(const QGlyph &, const QTransform &t) override;
+    virtual QImage alphaMapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t) override;
+    virtual QImage alphaRGBMapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t) override;
 
     virtual QFixed lineThickness() const override;
     virtual QFixed underlinePosition() const override;
@@ -485,8 +485,6 @@ public:
 
     void setFallbackFamiliesList(const QStringList &fallbackFamilies);
 
-    static uchar highByte(glyph_t glyph); // Used for determining engine
-
     inline QFontEngine *engine(int at) const
     { Q_ASSERT(at < m_engines.size()); return m_engines.at(at); }
 
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_qpf2.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontengine_qpf2.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_qpf2.cpp
@@ -148,7 +148,7 @@ static inline const uchar *verifyTag(con
     return tagPtr + length;
 }
 
-const QFontEngineQPF2::Glyph *QFontEngineQPF2::findGlyph(glyph_t g) const
+const QFontEngineQPF2::Glyph *QFontEngineQPF2::findGlyph(glyph__t g) const
 {
     if (!g || g >= glyphMapEntries)
         return 0;
@@ -326,15 +326,15 @@ bool QFontEngineQPF2::getSfntTableData(u
     return true;
 }
 
-glyph_t QFontEngineQPF2::glyphIndex(uint ucs4) const
+QGlyph QFontEngineQPF2::glyphIndex(uint ucs4) const
 {
-    glyph_t glyph = getTrueTypeGlyphIndex(cmap, cmapSize, ucs4);
+    glyph__t glyph = getTrueTypeGlyphIndex(cmap, cmapSize, ucs4);
     if (glyph == 0 && symbol && ucs4 < 0x100)
         glyph = getTrueTypeGlyphIndex(cmap, cmapSize, ucs4 + 0xf000);
     if (!findGlyph(glyph))
         glyph = 0;
 
-    return glyph;
+    return {0, glyph};
 }
 
 bool QFontEngineQPF2::stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, QFontEngine::ShaperFlags flags) const
@@ -354,16 +354,16 @@ bool QFontEngineQPF2::stringToCMap(const
         QStringIterator it(str, str + len);
         while (it.hasNext()) {
             const uint uc = it.next();
-            glyphs->glyphs[glyph_pos] = getTrueTypeGlyphIndex(cmap, cmapSize, uc);
-            if(!glyphs->glyphs[glyph_pos] && uc < 0x100)
-                glyphs->glyphs[glyph_pos] = getTrueTypeGlyphIndex(cmap, cmapSize, uc + 0xf000);
+            glyphs->glyphs[glyph_pos] = QGlyph{0, getTrueTypeGlyphIndex(cmap, cmapSize, uc)};
+            if(!glyphs->glyphs[glyph_pos].glyph && uc < 0x100)
+                glyphs->glyphs[glyph_pos] = QGlyph{0, getTrueTypeGlyphIndex(cmap, cmapSize, uc + 0xf000)};
             ++glyph_pos;
         }
     } else {
         QStringIterator it(str, str + len);
         while (it.hasNext()) {
             const uint uc = it.next();
-            glyphs->glyphs[glyph_pos] = getTrueTypeGlyphIndex(cmap, cmapSize, uc);
+            glyphs->glyphs[glyph_pos] = QGlyph{0, getTrueTypeGlyphIndex(cmap, cmapSize, uc)};
 #if 0 && defined(DEBUG_FONTENGINE)
             QChar c(uc);
             if (!findGlyph(glyphs[glyph_pos].glyph) && !seenGlyphs.contains(c))
@@ -387,16 +387,16 @@ bool QFontEngineQPF2::stringToCMap(const
 void QFontEngineQPF2::recalcAdvances(QGlyphLayout *glyphs, QFontEngine::ShaperFlags) const
 {
     for (int i = 0; i < glyphs->numGlyphs; ++i) {
-        const Glyph *g = findGlyph(glyphs->glyphs[i]);
+        const Glyph *g = findGlyph(glyphs->glyphs[i].glyph);
         if (!g)
             continue;
         glyphs->advances[i] = g->advance;
     }
 }
 
-QImage QFontEngineQPF2::alphaMapForGlyph(glyph_t g)
+QImage QFontEngineQPF2::alphaMapForGlyph(const QGlyph &g)
 {
-    const Glyph *glyph = findGlyph(g);
+    const Glyph *glyph = findGlyph(g.glyph);
     if (!glyph)
         return QImage();
 
@@ -422,7 +422,7 @@ glyph_metrics_t QFontEngineQPF2::boundin
     QFixed ymax = 0;
     QFixed xmax = 0;
     for (int i = 0; i < glyphs.numGlyphs; i++) {
-        const Glyph *g = findGlyph(glyphs.glyphs[i]);
+        const Glyph *g = findGlyph(glyphs.glyphs[i].glyph);
         if (!g)
             continue;
 
@@ -440,10 +440,10 @@ glyph_metrics_t QFontEngineQPF2::boundin
     return overall;
 }
 
-glyph_metrics_t QFontEngineQPF2::boundingBox(glyph_t glyph)
+glyph_metrics_t QFontEngineQPF2::boundingBox(const QGlyph &glyph)
 {
     glyph_metrics_t overall;
-    const Glyph *g = findGlyph(glyph);
+    const Glyph *g = findGlyph(glyph.glyph);
     if (!g)
         return overall;
     overall.x = g->x;
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_qpf2_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontengine_qpf2_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine_qpf2_p.h
@@ -161,15 +161,15 @@ public:
     FaceId faceId() const override { return face_id; }
     bool getSfntTableData(uint tag, uchar *buffer, uint *length) const override;
 
-    virtual glyph_t glyphIndex(uint ucs4) const override;
+    virtual QGlyph glyphIndex(uint ucs4) const override;
     bool stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, ShaperFlags flags) const override;
     void recalcAdvances(QGlyphLayout *, ShaperFlags) const override;
 
     void addOutlineToPath(qreal x, qreal y, const QGlyphLayout &glyphs, QPainterPath *path, QTextItem::RenderFlags flags) override;
-    QImage alphaMapForGlyph(glyph_t t) override;
+    QImage alphaMapForGlyph(const QGlyph &t) override;
 
     glyph_metrics_t boundingBox(const QGlyphLayout &glyphs) override;
-    glyph_metrics_t boundingBox(glyph_t glyph) override;
+    glyph_metrics_t boundingBox(const QGlyph &glyph) override;
 
     QFixed ascent() const override;
     QFixed capHeight() const override;
@@ -185,7 +185,7 @@ public:
 
     bool isValid() const;
 
-    const Glyph *findGlyph(glyph_t g) const;
+    const Glyph *findGlyph(glyph__t g) const;
 
     static bool verifyHeader(const uchar *data, int size);
     static QVariant extractHeaderField(const uchar *data, HeaderTag tag);
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontmetrics.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontmetrics.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontmetrics.cpp
@@ -484,7 +484,7 @@ int QFontMetrics::leftBearing(QChar ch)
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     qreal lb;
     engine->getGlyphBearings(glyph, &lb);
@@ -517,7 +517,7 @@ int QFontMetrics::rightBearing(QChar ch)
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     qreal rb;
     engine->getGlyphBearings(glyph, 0, &rb);
@@ -679,7 +679,7 @@ int QFontMetrics::horizontalAdvance(QCha
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
     QFixed advance;
 
     QGlyphLayout glyphs;
@@ -731,7 +731,7 @@ int QFontMetrics::charWidth(const QStrin
 
         d->alterCharForCapitalization(ch);
 
-        glyph_t glyph = engine->glyphIndex(ch.unicode());
+        QGlyph glyph = engine->glyphIndex(ch.unicode());
         QFixed advance;
 
         QGlyphLayout glyphs;
@@ -806,7 +806,7 @@ QRect QFontMetrics::boundingRect(QChar c
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     glyph_metrics_t gm = engine->boundingBox(glyph);
     return QRect(qRound(gm.x), qRound(gm.y), qRound(gm.width), qRound(gm.height));
@@ -1449,7 +1449,7 @@ qreal QFontMetricsF::leftBearing(QChar c
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     qreal lb;
     engine->getGlyphBearings(glyph, &lb);
@@ -1482,7 +1482,7 @@ qreal QFontMetricsF::rightBearing(QChar
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     qreal rb;
     engine->getGlyphBearings(glyph, 0, &rb);
@@ -1609,7 +1609,7 @@ qreal QFontMetricsF::horizontalAdvance(Q
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
     QFixed advance;
 
     QGlyphLayout glyphs;
@@ -1680,7 +1680,7 @@ QRectF QFontMetricsF::boundingRect(QChar
 
     d->alterCharForCapitalization(ch);
 
-    glyph_t glyph = engine->glyphIndex(ch.unicode());
+    QGlyph glyph = engine->glyphIndex(ch.unicode());
 
     glyph_metrics_t gm = engine->boundingBox(glyph);
     return QRectF(gm.x.toReal(), gm.y.toReal(), gm.width.toReal(), gm.height.toReal());
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontsubset.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontsubset.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontsubset.cpp
@@ -200,8 +200,10 @@ static void checkRanges(QPdf::ByteStream
 QVector<int> QFontSubset::getReverseMap() const
 {
     QVector<int> reverseMap(0x10000, 0);
+    QGlyph g;
     for (uint uc = 0; uc < 0x10000; ++uc) {
-        int idx = glyph_indices.indexOf(fontEngine->glyphIndex(uc));
+        g = fontEngine->glyphIndex(uc);
+        int idx = glyph_indices.indexOf(g.glyph);
         if (idx >= 0 && !reverseMap.at(idx))
             reverseMap[idx] = uc;
     }
@@ -1210,10 +1212,10 @@ QByteArray QFontSubset::toTruetype() con
 
     uint sumAdvances = 0;
     for (int i = 0; i < numGlyphs; ++i) {
-        glyph_t g = glyph_indices.at(i);
+        glyph__t g = glyph_indices.at(i);
         QPainterPath path;
         glyph_metrics_t metric;
-        fontEngine->getUnscaledGlyph(g, &path, &metric);
+        fontEngine->getUnscaledGlyph({0, g}, &path, &metric);
         if (noEmbed) {
             path = QPainterPath();
             if (g == 0)
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qharfbuzzng.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qharfbuzzng.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qharfbuzzng.cpp
@@ -460,7 +460,8 @@ _hb_qt_font_get_nominal_glyph(hb_font_t
     QFontEngine *fe = static_cast<QFontEngine *>(font_data);
     Q_ASSERT(fe);
 
-    *glyph = fe->glyphIndex(unicode);
+    QGlyph g = fe->glyphIndex(unicode);
+    *glyph = g.glyph;
 
     return *glyph != 0;
 }
@@ -475,7 +476,8 @@ _hb_qt_font_get_variation_glyph(hb_font_
     Q_ASSERT(fe);
 
     // ### TODO add support for variation selectors
-    *glyph = fe->glyphIndex(unicode);
+    QGlyph g = fe->glyphIndex(unicode);
+    *glyph = g.glyph;
 
     return *glyph != 0;
 }
@@ -489,10 +491,11 @@ _hb_qt_font_get_glyph_h_advance(hb_font_
     Q_ASSERT(fe);
 
     QFixed advance;
+    QGlyph tmpGlyph = {0, glyph};
 
     QGlyphLayout g;
     g.numGlyphs = 1;
-    g.glyphs = &glyph;
+    g.glyphs = &tmpGlyph;
     g.advances = &advance;
 
     fe->recalcAdvances(&g, QFontEngine::ShaperFlags(hb_qt_font_get_use_design_metrics(font)));
@@ -508,7 +511,7 @@ _hb_qt_font_get_glyph_h_kerning(hb_font_
     QFontEngine *fe = static_cast<QFontEngine *>(font_data);
     Q_ASSERT(fe);
 
-    glyph_t glyphs[2] = { first_glyph, second_glyph };
+    QGlyph glyphs[2] = { {0, first_glyph}, {0, second_glyph} };
     QFixed advance;
 
     QGlyphLayout g;
@@ -530,7 +533,8 @@ _hb_qt_font_get_glyph_extents(hb_font_t
     QFontEngine *fe = static_cast<QFontEngine *>(font_data);
     Q_ASSERT(fe);
 
-    glyph_metrics_t gm = fe->boundingBox(glyph);
+    QGlyph g = {0, glyph};
+    glyph_metrics_t gm = fe->boundingBox(g);
 
     extents->x_bearing = gm.x.value();
     extents->y_bearing = gm.y.value();
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qrawfont.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qrawfont.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qrawfont.cpp
@@ -280,12 +280,12 @@ QImage QRawFont::alphaMapForGlyph(quint3
         return QImage();
 
     if (d->fontEngine->glyphFormat == QFontEngine::Format_ARGB)
-        return d->fontEngine->bitmapForGlyph(glyphIndex, QFixed(), transform);
+        return d->fontEngine->bitmapForGlyph({0, glyphIndex}, QFixed(), transform);
 
     if (antialiasingType == SubPixelAntialiasing)
-        return d->fontEngine->alphaRGBMapForGlyph(glyphIndex, QFixed(), transform);
+        return d->fontEngine->alphaRGBMapForGlyph({0, glyphIndex}, QFixed(), transform);
 
-    return d->fontEngine->alphaMapForGlyph(glyphIndex, QFixed(), transform);
+    return d->fontEngine->alphaMapForGlyph({0, glyphIndex}, QFixed(), transform);
 }
 
 /*!
@@ -303,7 +303,8 @@ QPainterPath QRawFont::pathForGlyph(quin
 
     QFixedPoint position;
     QPainterPath path;
-    d->fontEngine->addGlyphsToPath(&glyphIndex, &position, 1, &path, 0);
+    QGlyph glyph = {0, glyphIndex};
+    d->fontEngine->addGlyphsToPath(&glyph, &position, 1, &path, 0);
     return path;
 }
 
@@ -523,12 +524,12 @@ int QRawFont::weight() const
 */
 QVector<quint32> QRawFont::glyphIndexesForString(const QString &text) const
 {
-    QVector<quint32> glyphIndexes;
+    QVector<quint32> glyphsResult;
     if (!d->isValid() || text.isEmpty())
-        return glyphIndexes;
+        return glyphsResult;
 
     int numGlyphs = text.size();
-    glyphIndexes.resize(numGlyphs);
+    QVector<QGlyph> glyphIndexes(numGlyphs);
 
     QGlyphLayout glyphs;
     glyphs.numGlyphs = numGlyphs;
@@ -536,8 +537,11 @@ QVector<quint32> QRawFont::glyphIndexesF
     if (!d->fontEngine->stringToCMap(text.data(), text.size(), &glyphs, &numGlyphs, QFontEngine::GlyphIndicesOnly))
         Q_UNREACHABLE();
 
-    glyphIndexes.resize(numGlyphs);
-    return glyphIndexes;
+    glyphsResult.resize(numGlyphs);
+    for (int i = 0; i < numGlyphs; ++i)
+        glyphsResult[i] = glyphs.glyphs[i].glyph;
+
+    return glyphsResult;
 }
 
 /*!
@@ -563,10 +567,18 @@ bool QRawFont::glyphIndexesForChars(cons
         return false;
     }
 
+    QVarLengthArray<QGlyph> tmpGlyphs(*numGlyphs);
+
     QGlyphLayout glyphs;
     glyphs.numGlyphs = *numGlyphs;
-    glyphs.glyphs = glyphIndexes;
-    return d->fontEngine->stringToCMap(chars, numChars, &glyphs, numGlyphs, QFontEngine::GlyphIndicesOnly);
+    glyphs.glyphs = tmpGlyphs.data();
+    bool r = d->fontEngine->stringToCMap(chars, numChars, &glyphs, numGlyphs, QFontEngine::GlyphIndicesOnly);
+
+    QGlyph *it = glyphs.glyphs;
+    for (int i = 0; i < *numGlyphs; ++i, ++glyphIndexes, ++it)
+        *glyphIndexes = it->glyph;
+
+    return r;
 }
 
 /*!
@@ -611,11 +623,15 @@ bool QRawFont::advancesForGlyphIndexes(c
     if (!d->isValid() || numGlyphs <= 0)
         return false;
 
+    QVarLengthArray<QGlyph> tmpGlyphs(numGlyphs);
     QVarLengthArray<QFixed> tmpAdvances(numGlyphs);
 
     QGlyphLayout glyphs;
-    glyphs.glyphs = const_cast<glyph_t *>(glyphIndexes);
     glyphs.numGlyphs = numGlyphs;
+    glyphs.glyphs = tmpGlyphs.data();
+    for (int i = 0; i < numGlyphs; ++i)
+        glyphs.glyphs[i] = QGlyph{0, glyphIndexes[i]};
+
     glyphs.advances = tmpAdvances.data();
 
     bool design = layoutFlags & UseDesignMetrics;
@@ -811,7 +827,8 @@ QRectF QRawFont::boundingRect(quint32 gl
     if (!d->isValid())
         return QRectF();
 
-    glyph_metrics_t gm = d->fontEngine->boundingBox(glyphIndex);
+    QGlyph glyph = {0, glyphIndex};
+    glyph_metrics_t gm = d->fontEngine->boundingBox(glyph);
     return QRectF(gm.x.toReal(), gm.y.toReal(), gm.width.toReal(), gm.height.toReal());
 }
 
